<template>
  <div
    class="flex flex-col gap-4"
  >
    <div
      class="flex flex-col gap-4 border-2 rounded-lg p-5 border-black"
      id="filter"
    >
      <p class="text-2xl border-black border-b-2 border-opacity-100"># Svn Filter</p>

      <div class="flex gap-4 items-center">
        <svn-filter
          :activator-text="activatorText"
          :activator-icon="activatorIcon"
          :activator-variant="activatorVariant"
          :activator-color="activatorColor"
          :activator-height="activatorHeight"
          :show-results="showResults"
          :selected-filters="getActiveFiltersCount()"
          @add-filter="addFilter"
          @activator-clicked="displayOrHideFilterResulsts"
        />
      </div>

      <div
        :class="(showFilterResulsts && showResults) ?
          'flex' : (!showFilterResulsts && showResults) ?
            'hidden' : (showFilterResulsts && !showResults) ?
              'flex' : 'hidden'"
      >
        <div
          class="flex items-center flex-wrap gap-4 flex-1"
        >
          <svn-filter-item-chip
            v-for="item in selectedFilters"
            :key="item?.id"
            :item="item"
            :data="mockData"
            @update-selected-data-filters="updateSelectedDataFilters(item?.id, $event)"
            @delete-filter="deleteFilter(item?.id)"
          />

          <svn-filter
            v-if="selectedFilters?.length"
            activator-variant="text"
            activator-icon="mdi-plus"
            :activator-height="32"
            activator-text="Add filter"
            @add-filter="addFilter"
          />
        </div>
  
        <v-btn
          v-if="selectedFilters?.length"
          variant="text"
          :text="'Clear all'"
          color="primary"
          class="!normal-case !text-xs !font-medium"
          @click="clearSelectedFilters"
        />
      </div>
    </div>
  </div>
</template>

<script setup>
import { ref, watch } from "vue";
import SvnFilter from "@/components/filters/SvnFilter.vue";
import SvnFilterItemChip from "../../components/filters/SvnFilterItemChip.vue";

defineProps({
  mockData: { type: Array, default: () => [
    {
      id: 3,
      campaign_draft_id: 3,
      campaign_type: "one_to_one",
      can_set_copilot: true,
      categories: [
          {
              id: 1,
              title: "Tag1"
          },
          {
              id: 2,
              title: "Tag2"
          }
      ],
      completion: 0,
      deadline: "2023-12-24",
      deleted_at: null,
      employees_count: 1,
      startline: "2023-12-22",
      status: "published",
      title: "NEW"
    },
    {
      id: 2,
      campaign_draft_id: 2,
      campaign_type: "one_to_one",
      can_set_copilot: true,
      categories: [],
      completion: 100,
      deadline: "2023-12-24",
      deleted_at: null,
      employees_count: 1,
      startline: "2023-12-22",
      status: "published",
      title: "qsd"
    },
    {
      id: 1,
      campaign_draft_id: 1,
      campaign_type: "one_to_one",
      can_set_copilot: true,
      categories: [],
      completion: 0,
      deadline: "2023-12-15",
      deleted_at: null,
      employees_count: 1,
      startline: "2023-12-14",
      status: "published",
      title: "Campagne Interview X Roadmap"
    }
  ] },
  activatorText: { type: String, default: 'Filters' },
  activatorIcon: { type: String, default: 'mdi-filter-outline' },
  activatorVariant: { type: String, default: 'outlined' },
  activatorColor: { type: String, default: 'darkGrey' },
  activatorHeight: { type: Number, default: 48 },
})

const showResults = ref(false);
const showFilterResulsts = ref(true);
const selectedFilters = ref([]);
const mockData = ref([
  {
    id: 3,
    campaign_draft_id: 3,
    campaign_type: "one_to_one",
    can_set_copilot: true,
    categories: [
        {
            id: 1,
            title: "Tag1"
        },
        {
            id: 2,
            title: "Tag2"
        }
    ],
    completion: 0,
    deadline: "2023-12-24",
    deleted_at: null,
    employees_count: 1,
    startline: "2023-12-22",
    status: "published",
    title: "NEW"
  },
  {
    id: 2,
    campaign_draft_id: 2,
    campaign_type: "one_to_one",
    can_set_copilot: true,
    categories: [],
    completion: 100,
    deadline: "2023-12-24",
    deleted_at: null,
    employees_count: 1,
    startline: "2023-12-22",
    status: "published",
    title: "qsd"
  },
  {
    id: 1,
    campaign_draft_id: 1,
    campaign_type: "one_to_one",
    can_set_copilot: true,
    categories: [],
    completion: 0,
    deadline: "2023-12-15",
    deleted_at: null,
    employees_count: 1,
    startline: "2023-12-14",
    status: "published",
    title: "Campagne Interview X Roadmap"
  }
])

const getActiveFiltersCount = () => {
  return selectedFilters?.value?.filter(el => el.active === true).length
}

const addFilter = (item) => {
  selectedFilters.value.push({ ...item, active: false })
  showFilterResulsts.value = true
}

const deleteFilter = (id) => {
  selectedFilters.value.splice(selectedFilters.value.findIndex(el => el.id === id), 1)
  checkShowResulsts()
}

const clearSelectedFilters = () => {
  selectedFilters.value = []
  showFilterResulsts.value = false
  showResults.value = false
}

const updateSelectedDataFilters = (id, e) => {
  let found = selectedFilters?.value?.find(el => el.id === id)
  if (e?.length) {
    found.active = true
    checkShowResulsts()
  }
  else {
    found.active = false
    checkShowResulsts()
  }
}

const displayOrHideFilterResulsts = () => {
  showFilterResulsts.value = !showFilterResulsts.value
}

const checkShowResulsts = () => {
  if (selectedFilters?.value?.filter(el => el.active === true).length) {
    showResults.value = true
  }
  else {
    showResults.value = false
  }
}

watch(selectedFilters.value, (newValue, oldValue) => {
  if (newValue.length > 0) {
    showFilterResulsts.value = true
  }
  else {
    showFilterResulsts.value = false
  }
})
</script>

<style scoped>

</style>